<template>
  <h2>{{ t(`page.settings.profile.title`) }}</h2>
  <div class="Profile__Data">
    <div
      v-for="datum in data"
      :key="datum.property"
      class="Profile__Datum p-inputgroup"
    >
      <span class="p-inputgroup-addon">
        <i :class="datum.icon"></i>
      </span>
      <span class="p-float-label">
        <p-InputText
          :id="`${uuid}+${datum.property}`"
          v-model="settings.user[datum.property]"
          :class="{ [`Profile__Data${datum.property}`]: true }"
          :type="datum.type"
        />
        <label :for="`${uuid}+${datum.property}`">{{
          t(`page.settings.profile.${datum.property}`)
        }}</label>
      </span>
    </div>

    <AvatarCreator />
  </div>
</template>

<script lang="ts" setup>
import { onMounted, watch } from 'vue'
import { addMessage, settings, updateCurrentUser } from '@/states'
import { User, userClient } from '@/api'
import { hasUuid } from '@/components/HasUuid'
import { useI18n } from 'vue-i18n'
import { ReactiveRecorder } from '@/components/form/ReactiveRecorder'
import AvatarCreator from '@/components/avatar/Creator/AvatarCreator.vue'

const uuid = hasUuid().uuid
const t = useI18n().t

/**
 * Fields reference for partial patch
 */
const recorder = new ReactiveRecorder(() => settings.user)

/**
 * Field descriptions
 */
type UserDatum = {
  property: keyof User
  type: string
  icon: string
}
const data: UserDatum[] = [
  {
    property: 'name',
    icon: 'mdi mdi-account-outline',
    type: 'text',
  },
]

onMounted(async () => {
  await updateCurrentUser()
  recorder.reset()
})

const patchUser = async () => {
  if (!Object.keys(recorder.result.value.changes).length) return
  try {
    await userClient.patch(settings.user.id, recorder.result.value.changes)
    addMessage({
      severity: 'success',
      summary: t('page.settings.success') as string,
      detail: t('page.settings.profile.success.detail') as string,
      life: 3000,
    })
    await updateCurrentUser()
    recorder.reset()
  } catch (e) {
    console.error(e)
    addMessage({
      severity: 'error',
      summary: t('page.settings.error') as string,
      detail: String(e),
      life: 5000,
    })
  }
}

/**
 * Debounce patchUser
 */
let timeout = 0
watch(
  () => recorder.result.value.changes,
  async () => {
    if (timeout) window.clearTimeout(timeout)
    timeout = window.setTimeout(patchUser, 1000)
  },
  { deep: true }
)
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;

.Profile__Datum {
  max-width: v.$minWidth;
  margin-top: v.$spacing * 2;
}
</style>
